local gr, lm, pi, atan = love.graphics, love.mouse, math.pi, math.atan

local spider		= {
		image	= gr.newImage( 'spider.png' ),
		w		= 120,
		h		= 148,
		quad	= {},
		frame	= 1,
		size	= 0.75,
		loc		= { screen[1]/2, screen[2]/2 },
		angle	= 0,
		delay	= 0.01,		-- time (sec) between sprite changes
		lapsed	= 0,		-- time waiting before delay complete
		speed	= 0.008,	-- how fast spider will move

		init	= function( s )
			s.cols = {4,4,4,4,3}
			s.rows = #s.cols
			for r = 0, s.rows-1 do
				for c = 0, s.cols[r+1]-1 do
					s.quad[#s.quad+1] = gr.newQuad( s.w*c, s.h*r, s.w, s.h, s.image:getWidth(), s.image:getHeight() )
					end
				end
			end,

		update	= function( s, tk )
			s.lapsed		= s.lapsed + tk
			if s.lapsed		> s.delay then
				s.frame		= s.frame < #s.quad and s.frame + 1 or 1
				s.lapsed	= 0
				end
			local mouse		= { lm.getPosition() }
			s.loc, s.angle	= move( s.loc, mouse, s.speed )
			local dis		= (s.loc[1]-mouse[1])^2 + (s.loc[2]-mouse[2])^2
			s.delay			= 1/dis + .01	-- prevents delay from getting too short
			if dis < 5 then
				gr.setColor( 255, 0, 0 )
				love.mouse.setVisible( false )
				else
				gr.setColor( 255, 255, 255 )
				love.mouse.setVisible( true )
				end
			end,

		draw = function( s )
			gr.draw( s.image, s.quad[s.frame], s.loc[1],s.loc[2], s.angle,s.size,s.size,s.w/2,s.h/2-20 )
			end
		}

function getAngle( a, b )
	if a[1] == b[1] and a[2] == b[2] then return 0 end
	local an = atan( (b[1]-a[1]) / (b[2]-a[2]) )
	an = a[2]-b[2] < 0 and an - pi or an > 0 and an - 2*pi or an
	return -an
	end

function move( a, b, s )	-- s controls speed of approach
	local s  = s or 1
	local an = getAngle( a, b )
	local dx = b[1] - a[1]
	local dy = b[2] - a[2]
	if a[1] ~= b[1] and a[2] ~= b[2] then
		gr.push()
			gr.translate( a[1], a[2] )
			gr.rotate( an )
			a[1] = a[1] + dx * s
			a[2] = a[2] + dy * s
			gr.pop()
		end
	return a, an
	end

return spider
